//------------------------------------------------------------------------------
//
//  npctrl.h
//
// ANTZ - 3D data viewer with realtime real-world interaction based on NPE.
//
// ANTZ is hosted at http://temporalzone.com and NPE at http://neuralphysics.org
//
// Written in 2010-2012 by Shane Saxon - contact@saxondigital.net
//
// Additional code contributed by: Mark Buchanan and Lucas Erickson.
//
// To the extent possible under law, the author(s) have dedicated all copyright 
// and related and neighboring rights to this software to the public domain
// worldwide. This software is distributed without any warranty.
//
// Released under the CC0 license, which is GPL compatible.
//
// You should have received a copy of the CC0 Public Domain Dedication along
// with this software (license file named COPYING.txt). If not, see
// http://creativecommons.org/publicdomain/zero/1.0/
//
//------------------------------------------------------------------------------

#ifndef npctrl_H_
#define npctrl_H_

#ifdef __cplusplus
	extern "C" {
#endif
//------------------------------------------------------------------------------

void npInitCtrl (void* dataRef);

void npCloseCtrl (void* dataRef);

void npUpdateCtrl (void* dataRef);					//typically once per frame


int npAppLoop(void* dataRef);

void npCtrlCommand (int command, void* dataRef);   //apply to all selected nodes

void npCtrlCommandSet (int command, void* node, void* dataRef);	// specific node

#ifdef __cplusplus
	}
#endif
#endif

